/**
 *  Copyright (C) 2009 Emerson Ribeiro de Mello, Fernando Fernandes Simão
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 *  Copyright (C) 2009 Emerson Ribeiro de Mello, Fernando Fernandes Simão
 *
 *  Este programa é software livre; você pode redistribuí-lo e/ou
 *  modificá-lo sob os termos da Licença Pública Geral GNU, conforme
 *  publicada pela Free Software Foundation; tanto a versão 2 da
 *  Licença como (a seu critério) qualquer versão mais nova.
 *
 *  Este programa é distribuído na expectativa de ser útil, mas SEM
 *  QUALQUER GARANTIA; sem mesmo a garantia implícita de
 *  COMERCIALIZAÇÃO ou de ADEQUAÇÃO A QUALQUER PROPÓSITO EM
 *  PARTICULAR. Consulte a Licença Pública Geral GNU para obter mais
 *  detalhes.
 *
 *  Você deve ter recebido uma cópia da Licença Pública Geral GNU
 *  junto com este programa; se não, escreva para a Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
 *  02111-1307, USA.
 */
package objetos;

import abstrata.Personagem;
import java.util.ArrayList;
import java.util.Random;
import javax.swing.JPanel;

public class Inimigo extends Personagem {

    private Random r; // gera o valor da vida do inimigo aleatoriamente
    public int vidaInimigo; // armazena a vida do inimigo
    private boolean visivel; // visibilidade do tiro inimigo
    public int velocidadeInimigo; // velocidade horizontal
    public int velocidadeVertical; // velocidade vertical
    public ArrayList<CanhaoDePlasma> canhaoInimigo; // vetor de tiros do inimigo

    public Inimigo(String nomeImagem, JPanel jp, int px, int py, int velocidade, int velocidadeVertical) {
        super(nomeImagem, jp, px, py);
        // Cada inimigo nasce com uma vida com valores de 10 a 100, escolhido aleatoriamente
        r = new Random();
        vidaInimigo = r.nextInt(90) + 10;
        this.visivel = true;
        canhaoInimigo = new ArrayList<CanhaoDePlasma>();
        this.velocidadeInimigo = velocidade;
        this.velocidadeVertical = velocidadeVertical;
    }

    /**
     * Retorna a vida do inimigo
     * @return vidaInimigo
     */
    public int obterVidaInimigo() {
        return vidaInimigo;
    }

    /**
     *  Algoritmo para movimentacao horizontal e vertical do inimigo
     */
    public void movimentarInimigo() {
        // movimentaçao horizontal
        x -= velocidadeInimigo;
        if (x < 0) {
            x = tela.getWidth();
        }
        //movimentaçao vertical
        int posicaoY = r.nextInt(velocidadeVertical);
        // se for true, incrementa a posicaoY
        boolean increY = r.nextBoolean();
        if (increY == true) {
            // tratando os limites da altura da tela - eixo Y
            if (getY() + getAltura() + posicaoY < tela.getHeight()) {
                incrementaY(posicaoY);
            } else {
                setY(tela.getHeight() - getAltura());
            }
            // se for falso, decrementa a posicaoY
        } else {
            // tratando os limites da altura da tela - eixo Y
            if (getY() - posicaoY > 0) {
                incrementaY(posicaoY * -1);
            } else {
                setY(0);
            }
        }
    }
}
